#
# $Id: firefox.spec,v 1.0 2004/10/21 15:48:39 legion Exp $
#
%def_without debug
%def_without svg
%def_with    xprint
%def_with    branding

%if_with debug
%set_strip_method none
%endif # debug

Summary:        The Mozilla Firefox project is a redesign of Mozilla's browser
Name:           firefox
Version:        1.0.8
Release:       	alt0.M30.1
License:        MPL
Group:          Networking/WWW
URL:            http://www.mozilla.org/projects/firefox/

Packager:	L.A. Kostis <lakostis@altlinux.org>

Source0:	%name-%version-source.tar.bz2
Source1:	%name-1.0-icons.tar.bz2
Source3:	%name-build-scripts.tar.bz2
Source4:	rpm.macros.%name
Source5:	%name-rebuild-databases.sh
Source6:	.mozconfig-firefox
Source7:	%name-searchplugins-addon-1.0.tar.bz2
Source8:	%name-1.0.5-alt-rpm-scripts.tar.bz2
Source9:	%name-0.9-alt-ssl-addon-certs.txt
Source10:	%name.desktop
Source11:	%name.firsttime
Source12:	S10firefox.common.langs.sh
Source13:	S000userhome.sh

Patch1:		firefox-1.0.8-alt-browser-home-page.patch
Patch2:		firefox-1.0.7-alt-run-mozilla.patch
Patch3:		firefox-1.0.6-20050724.1-alt-nox.patch
Patch6:		firefox-configure_in.patch
Patch7:		firefox-1.0-alt-url-handler.patch
Patch8:		firefox-1.0.5-alt-prefs-tuning.patch
Patch9:		firefox-1.0-user-searchplugins-dir.patch
Patch10:	firefox-190031.branch3.patch
Patch11:	firefox-234035-4xftonly.patch
Patch12:	firefox-1.0.1-layout-svg-cairo.patch

Patch13:	firefox-1.0.3-certdata-perl-fix.patch
Patch14:	firefox-1.0.3-nss-make-fix.patch
Patch15:	mozilla-1.7.9-alt-gssapi.patch 

# Mandriva patches

Patch20:	mozilla-firefox-1.0-lib64-nspr.patch.bz2
Patch21:	mozilla-firefox-1.0-lib64.patch.bz2
Patch22:	mozilla-firefox-1.0.6-fixwarnings.patch.bz2

# Security fixes

# Automatically added by buildreq on Tue Jul 13 2004
BuildRequires: xorg-x11-libs doxygen fontconfig-devel freetype2-devel 
BuildRequires: gcc-c++ glib2-devel libIDL-devel libatk-devel libgtk+2-devel libjpeg-devel 
BuildRequires: libpango-devel libpng-devel libstdc++-devel pkgconfig unzip zip zlib-devel
BuildRequires: chrpath menu-devel browser-plugins-npapi-devel

BuildRequires: autoconf_2.13

%{?_with_svg:BuildRequires: cairo-devel libpixman-devel}

Requires:	gtk+2 >= 2.2.0 url_handler >= 0.2.1-alt2 freetype2 indexhtml browser-plugins-npapi zip
Provides:	webclient

Conflicts:      firefox < 0.9

%define fullname		%name-%version
%define firefox_prefix  	%_libdir/%fullname
%define firefox_run		%firefox_prefix/run-mozilla.sh
%define firefox_extensionsdir	%firefox_prefix/extensions
%define firefox_initd		%firefox_prefix/init.d 

%description
The Mozilla Firefox project is a redesign of Mozilla's browser component,
written using the XUL user interface language and designed to be
cross-platform.

%package devel
Requires: %name = %version-%release
Summary: The Mozilla Firefox development files
Group: Development/Other

%description devel
The Mozilla Firefox development files

%prep
%setup -q -n %name-%version -c 
%setup -q -n %name-%version/mozilla -T -D -a1
%setup -q -n %name-%version/mozilla -T -D -a3

%patch1 -p1 -b .browser-home-page
%patch2 -p1 -b .run-scripts
%patch3 -p1 -b .nox
%patch6 -p1 
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p0
%patch11 -p0
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1

%patch20 -p1
%patch21 -p1
%patch22 -p1

# change .mozconfig
%__cp -f %SOURCE6 ./.mozconfig

# additional CA certificates
cd %_builddir/%name-%version/mozilla/security/nss/lib/ckfw/builtins
cat %SOURCE9 >> certdata.txt
%make generate
cd -

%build
for d in build/autoconf \
	 nsprpub/build/autoconf \
	 directory/c-sdk/config/autoconf
do
    install -m755 %_datadir/automake/config.{guess,sub} $d
done

%set_autoconf_version 2.13
%__autoconf

%add_optflags %optflags_shared
%add_findprov_lib_path %_libdir/%fullname
export MOZ_PHOENIX=1 MOZILLA_OFFICIAL=1 BUILD_OFFICIAL=1
export LIBIDL_CONFIG=/usr/bin/libIDL-config-2

# Add fake RPATH
rpath="/$(printf %%s '%firefox_prefix' |tr '[:print:]' '_')"
export LDFLAGS="$LDFLAGS -Wl,-rpath,$rpath"

%configure \
	--disable-ldap \
	--disable-mailnews \
	--enable-extensions=cookie,xml-rpc,xmlextras,pref,transformiix,universalchardet,webservices,inspector,gnomevfs,negotiateauth \
	--enable-crypto \
	--enable-nspr-autoconf \
	--without-system-nspr \
	--disable-composer \
	--enable-single-profile \
	--disable-profilesharing \
	--prefix=%_prefix \
	--includedir=%_includedir/%name \
	--disable-tests \
	--disable-freetype2 \
	--enable-xft \
	--enable-necko-protocols=all \
	--enable-default-toolkit=gtk2 \
	--enable-reorder \
	--enable-shared \
%ifnarch x86_64
	--enable-elf-dynstr-gc \
%endif # x86_64
%if_with debug
	--disable-strip \
	--enable-debug \
	--enable-debug-modules \
	--enable-logrefcnt \
	--enable-debugger-info-modules \
	--enable-detect-webshell-leaks \
%else
	--enable-strip \
	--enable-strip-libs \
	--disable-debug \
%endif # debug
%if_with svg
	--enable-svg \
  	--enable-svg-renderer-cairo \
%endif # svg
%if_with xprint
	--enable-xprint \
%else
	--disable-xprint \
%endif # xprint
%if_with branding
	--enable-official-branding \
%endif
	--with-system-jpeg \
	--with-system-png \
	--with-system-zlib \
	--with-pthreads \
	--disable-installer \
	#

%make_build \
	prefix=%_prefix \
	idldir=%_datadir/idl/%name \
	mozappdir=%firefox_prefix \
	MOZ_PHOENIX=1 

%install
%__mkdir_p \
    %buildroot/%firefox_prefix/install \
    %buildroot/%firefox_extensionsdir \
    %buildroot/%_datadir/%fullname/scripts 

%makeinstall \
	idldir=%buildroot/%_datadir/idl/%name \
	includedir=%buildroot/%_includedir/%name \
	mozappdir=%buildroot/%firefox_prefix \
	MOZ_PHOENIX=1 

%__rm -rf %buildroot/%firefox_prefix/install

# update plugins
subst 's,%%PLUGIN_PATH%%,%browser_plugins_path,' %buildroot/%_bindir/%name

# make package link 
%__ln_s %fullname %buildroot/%_libdir/%name
%__ln_s %fullname %buildroot/%_datadir/%name

# Add search plugins
cd %buildroot/%_libdir/%name
	%__tar jxf %SOURCE7
cd -

# install menu file
%__install -D -m 644 %SOURCE10 %buildroot/%_datadir/applications/%name.desktop

%__mkdir_p %buildroot/%_menudir
%Md2m \
	%name \
	"Networking/WWW" \
	%buildroot/%_datadir/applications/%name.desktop \
	%buildroot/%_menudir/%name \
	x11

# icons
%__install -D -m 644 mozicon48.png %buildroot/%_liconsdir/%name.png
%__install -D -m 644 mozicon32.png %buildroot/%_iconsdir/%name.png
%__install -D -m 644 mozicon16.png %buildroot/%_miconsdir/%name.png

# RPM MACRO
%__install -D -m 644 %SOURCE4 %buildroot%_sysconfdir/rpm/macros.d/%name

cd %buildroot/%_datadir/%fullname/scripts
	%__tar jxf %SOURCE8
cd -

# Install firsttime script.
%__install -D -m 755 %SOURCE11                                  %buildroot/%_sysconfdir/firsttime.d/%name-%version
%__subst 's,@firefox_bin@,%_bindir/%name,g'                     %buildroot/%_sysconfdir/firsttime.d/%name-%version
%__subst 's,@firefox_run@,%firefox_run,g'                       %buildroot/%_sysconfdir/firsttime.d/%name-%version
%__subst 's,@firefox_scriptdir@,%_datadir/%fullname/scripts,g'  %buildroot/%_sysconfdir/firsttime.d/%name-%version
%__subst 's,@firefox_extensionsdir@,%firefox_extensionsdir,g'   %buildroot/%_sysconfdir/firsttime.d/%name-%version

# Install script to switch language after language packs installation.
%__install -D -m 755 %SOURCE12                                  %buildroot/%firefox_initd/S10firefox.common.langs.sh
%__subst 's,@firefox_extensionsdir@,%firefox_extensionsdir,g'   %buildroot/%firefox_initd/S10firefox.common.langs.sh

# ALT-specific
%__install -D -m 755 %SOURCE13                                  %buildroot/%firefox_initd/S000userhome.sh

# move Firefox stuff
%__install -D -m 600 %SOURCE5 %buildroot/%_libdir/%fullname/rebuild-databases.sh

# We must rename some file to remove comflicts between Mozilla, Firefox and Thunderbird pckages. 
find %buildroot/%_datadir/aclocal -type f | 
while read f ; do
%__mv -f "$f" "%buildroot/%_datadir/aclocal/%name-${f##*/}"
done

# make devel source packege to build extensions
%__mkdir_p %buildroot/%_usrsrc/%name
find %buildroot/%_libdir/%name \
     %buildroot/%_includedir/%name \
     %buildroot/%_datadir/idl/%name \
-follow -xtype f |sed 's,^%buildroot/\(.*\)$,\1,' > ./%name-content-index

%__tar -jcf %buildroot/%_usrsrc/%name/sources.tar.bz2 \
    ./makemake.sh ./build_dist.sh find_install.sh     \
    ./%name-content-index                             \
    ./build                                           \
    ./config                                          \
    ./browser                                         \
    ./.mozconfig                                      \
    ./mozilla-config.h

# Add real RPATH
rpath="/$(printf %%s '%firefox_prefix' |tr '[:print:]' '_')"
find "%buildroot/%firefox_prefix" -type f | 
while read f; do
  %__file "$f" | grep -qs ELF || continue
  if chrpath -l "$f" | fgrep -qs "RPATH=$rpath"; then
	  chrpath -r "%firefox_prefix" "$f"
  fi
done

%triggerpostun -n %name -- %name > %version
[ ! -d "%firefox_prefix/extensions" ] || %__rm -rf "%firefox_prefix/extensions"
[ ! -d "%firefox_prefix/chrome/overlayinfo" ] || %__rm -rf "%firefox_prefix/chrome/overlayinfo"
%__rm -f %firefox_prefix/chrome/*.rdf
%__rm -f %firefox_prefix/component.reg
%__rm -f %firefox_prefix/defaults.ini
%__rm -f %firefox_prefix/components.ini
%__rm -f %firefox_prefix/components/*.dat

%triggerin -n %name -- %name < 1.0.5
printf '\n\nWARNING! WARNING! WARNING!\nPlease make reinstall all your Firefox extentions after version change or Firefox upgrade.\n\n'

%preun
if [ "$1" = "0" ]; then
    [ ! -d "%firefox_prefix/extensions" ] || %__rm -rf "%firefox_prefix/extensions"
    [ ! -d "%firefox_prefix/chrome/overlayinfo" ] || %__rm -rf "%firefox_prefix/chrome/overlayinfo"
    %__rm -f %firefox_prefix/chrome/*.rdf
    %__rm -f %firefox_prefix/component.reg
    %__rm -f %firefox_prefix/defaults.ini 
    %__rm -f %firefox_prefix/components.ini
    %__rm -f %firefox_prefix/components/*.dat
fi

%post 
%update_menus
[ -n "$DURING_INSTALL" ] ||
    %_datadir/%fullname/scripts/firefox_register.sh %firefox_prefix/%name-bin

%postun
%clean_menus

%files 
%_bindir/%name
%_sysconfdir/firsttime.d/%name-%version
%_libdir/%name
%firefox_prefix
%_datadir/%name
%_datadir/%fullname
%defattr(0644,root,root,0755)
%_menudir/*
%_datadir/applications/%name.desktop
%_iconsdir/%name.png
%_miconsdir/%name.png
%_liconsdir/%name.png
%doc LEGAL LICENSE

%files devel
%_sysconfdir/rpm/macros.d/%name
%_bindir/%name-config
%_includedir/%name
%_datadir/aclocal/*
%_datadir/idl/%name
%_libdir/pkgconfig/*
%_usrsrc/%name

%changelog
* Thu Apr 18 2006 LAKostis <lakostis at altlinux.ru> 1.0.8-alt0.M30.1
- new version fixing various security bugs:
  + MFSA 2006-25  Privilege escalation through Print Preview
  + MFSA 2006-24 Privilege escalation using crypto.generateCRMFRequest
  + MFSA 2006-23 File stealing by changing input type
  + MFSA 2006-22 CSS Letter-Spacing Heap Overflow Vulnerability
  + MFSA 2006-19 Cross-site scripting using .valueOf.call()
  + MFSA 2006-18 Mozilla Firefox Tag Order Vulnerability
  + MFSA 2006-17 cross-site scripting through window.controllers
  + MFSA 2006-16 Accessing XBL compilation scope via valueOf.call()
  + MFSA 2006-15 Privilege escalation using a JavaScript function's cloned parent
  + MFSA 2006-14 Privilege escalation via XBL.method.eval
  + MFSA 2006-13 Downloading executables with "Save Image As..."
  + MFSA 2006-12 Secure-site spoof (requires security warning dialog)
  + MFSA 2006-11 Crashes with evidence of memory corruption (rv:1.8)
  + MFSA 2006-10 JavaScript garbage-collection hazard audit
  + MFSA 2006-09 Cross-site JavaScript injection using event handlers
  + MFSA 2006-05 Localstore.rdf XML injection through XULDocument.persist()
  + MFSA 2006-03 Long document title causes startup denial of Service
  + MFSA 2006-01 JavaScript garbage-collection hazards

* Wed Oct 12 2005 LAKostis <lakostis at altlinux.ru> 1.0.7-alt3
- sync with 3.0-branch changes.
- disable official installer (due internal zlib addiction).
- relax requires for xprint build.
- new version fixing various security bugs.
- add xprint support by default.
- add strip-libs in non-debug build.
- update run-mozilla patch.

* Mon Sep 05 2005 Alexey Gladkov <legion@altlinux.ru> 1.0.6-alt5.3
- default startpage.

* Mon Sep 05 2005 Alexey Gladkov <legion@altlinux.ru> 1.0.6-alt5.2
- firsttime bugfix.

* Fri Aug 26 2005 Alexey Gladkov <legion@altlinux.ru> 1.0.6-alt5.1
- rpm mascros bugfix.
- The script is added for switching language after installation/removal 
  of a localization package.
- command line shortcut added: altfaq:NUM .
- Bug: #7682 fixed.

* Tue Aug 16 2005 Alexey Gladkov <legion@altlinux.ru> 1.0.6-alt4
- major bugfix.
- build with official branding.
- x86_64 compatibility addon (patch20, patch21).

* Sun Aug 07 2005 Alexey Gladkov <legion@altlinux.ru> 1.0.6-alt3
- release version.
- firsttime script added.
- SVG support disabled.
- Patch #2 bugfix (bug: #7682)

* Sun Jul 24 2005 LAKostis <lakostis at altlinux.ru> 1.0.6-alt2.cvs
- fix -nox patch.
- add gssapi detection and build fixes from mhz@.

* Tue Jul 19 2005 LAKostis <lakostis at altlinux.ru> 1.0.6-alt1.cvs
- new version from aviary branch fixing various bugs:
  + MFSA2005-54
  + Restore API compatibility for extensions and web applications 
    that did not work in Firefox 1.0.5.
  
* Mon Jul 11 2005 LAKostis <lakostis at altlinux.ru> 1.0.5-alt2.cvs
- new version from aviary branch;

* Wed Jun 22 2005 LAKostis <lakostis at altlinux.ru> 1.0.5-alt1.cvs
- new version from aviary branch fixing various security bugs;
- fix: #4846, #5101, #7126 (legion).
- if_{with,without} debug - added (legion).
- keyword 'altbug:' added, patch2 updated (legion).
- postin/postun-scripts scripts bugfixes (legion).
- triggers added for trash cleanup (legion).

* Mon Jun 20 2005 LAKostis <lakostis at altlinux.ru> 1.0.5-alt0.cvs
- new version from aviary branch;
- fix #6595;
- add switches for svg/xprint easy builds.
- update alt-prefs-tuning.patch (disable annoying default browser dialog).

* Sun Jun 12 2005 LAKostis <lakostis at altlinux.ru> 1.0.4-alt1
- new version;
- SA15601 security fix;
- BuildRequires cleanup (remove xorg-x11-libs-static).

* Thu Apr 21 2005 Alexey Gladkov <legion@altlinux.ru> 1.0.3-alt1
- new version;
- requires fix;

* Wed Apr 13 2005 Alexey Gladkov <legion@altlinux.ru> 1.0.2-alt1
- new version;
- RPATH fix;
- NoX patch was rewritten;

* Sun Mar 06 2005 Alexey Gladkov <legion@altlinux.ru> 1.0.1-alt2
- rpm macros was updated;

* Fri Feb 25 2005 Alexey Gladkov <legion@altlinux.ru> 1.0.1-alt1
- new version;
- patch9 was added (mozilla Bug #123315);
- patch10, patch11 was added (#6151);

* Mon Feb 14 2005 Alexey Gladkov <legion@altlinux.ru> 1.0-alt7
- plugins path bugfix;
- svg support added;
- x86_64 compatibility added (thx mouse@);

* Tue Feb 01 2005 Alexey Gladkov <legion@altlinux.ru> 1.0-alt6
- update patch firefox-1.0-20050201-alt-nox.patch 
  * uninstall-global-theme command-line option was added;
  * update-register command-line option was added;
- firefox-1.0-alt-rpm-scripts.tar.bz2 bugfix;

* Thu Jan 27 2005 Alexey Gladkov <legion@altlinux.ru> 1.0-alt5
- disable svg support becouse svg layout lead to segfault 
  when mozilla compile with gcc3.4 .
- search plugins was moved into the standalone rpm package.

* Wed Jan 19 2005 Alexey Gladkov <legion@altlinux.ru> 1.0-alt4
- Rebuilt with libstdc++.so.6.

* Wed Jan 05 2005 Alexey Gladkov <legion@altlinux.ru> 1.0-alt3
- new version;
- browser-plugins-npapi support added;
- new icons default icons(thx shrek@);
- option uninstall-global-extension was fixed;

* Wed Nov 03 2004 Alexey Gladkov <legion@altlinux.ru> 1.0-alt2.rc1
- extension sheme changes;
- postin/preun scripts chenges;

* Mon Oct 18 2004 Alexey Gladkov <legion@altlinux.ru> 1.0-alt2.PR
- new default extensions added;
- protocol 'mailto' external handler added; 
- firefox.macro changed;
- postun script changed;
- icons changed;

* Thu Sep 30 2004 Alexey Gladkov <legion@altlinux.ru> 1.0-alt1.PR
- New version 1.0PR;
- New extension scheme;
- Add:
    * New option 'run-without-x' added (mouse, legion);
    * SVG support added;
    * Certificate (ALT Linux CA Root) added;
    * ALT Linux BTS search plugin added;
    * RPATH added to all binary files;
- bug #4284 fixed;

* Fri May 28 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt4
- Move back some changes at alt3 build.
- Bug #4157 fixed.

* Fri Apr 30 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt3.1
- viewsource protocol was added.

* Thu Apr 29 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt3
- Minimize buildin extensions;
- Disable debug output;
- Disable some options:
  + disable JavaScript debug library;
  + disable LDAP support;
  + disable logging facilities;
- Necko protocols cleanup;

* Tue Feb 24 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt2
- Splash screen added (thx sadist@);
- Search plugins added;
- Remove devel package Conflicts;
- Change rebuild-database.sh script. Script must be run only as root;
- Change locale hack.

* Wed Feb 11 2004 Alexey Gladkov <legion@altlinux.ru> 0.8-alt1
- Mozilla Firebird becomes Mozilla Firefox. Mozilla's next 
  generation browser has changed names (again);
- New version;

* Sun Jan 11 2004 Alexey Gladkov <legion@altlinux.ru> 0.7-alt2
- Spec changes.
- run-mozilla.sh script patch.

* Tue Dec 30 2003 Alexey Gladkov <legion@altlinux.ru> 0.7-alt1
- first build for ALT Linux.
- rpm macro created.
- new scheme loading extensions added (thx force@)
